/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2014, 2015 (c)
 * 
 *    file: defs.h
 *    This file is part of the GoSnake project.
 *
 *    GoSnake is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    GoSnake is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with GoSnake.  If not, see <http://www.gnu.org/licenses/>.
 */    

#ifndef __GO_SNAKE
#define __GO_SNAKE

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <pwd.h>
#include <console/dialogs.h>

typedef enum
{ UP = 1, DOWN, LEFT_1, LEFT_2, RIGHT_1, RIGHT_2 }
direction_e;

#define SNAKE_UP_DOWN		'*'//219
#define SNAKE_LEFT_RIGHT_1	'*'//220
#define SNAKE_LEFT_RIGHT_2	'*'//223
#define BRICK_WALL		178

#define MAX_LENGTH		100
#define MAX_LEVEL		18

#define BASE_SPEED		50000
#define MAX_SPEED		10000
#define MIN_SPEED		500000
#define SPEED_STEP		10000

#define DEFAULT_MAX_SCORE	10

typedef struct
{
  int x, y;				//position of snake head
  int length;				//snake length
  direction_e body[MAX_LENGTH];		//direction of each body part
  int body_x[MAX_LENGTH];		//x position of body parts
  int body_y[MAX_LENGTH];		//y position of body parts
} snake_s;
snake_s snake;

int LEVEL;
int score;
int level_score;
//int speed = 50000;

typedef struct
{
  int x, y;
  char type;
  int score_inc;
} food_s;
food_s food;

struct passwd *pass;//will be used to find the home dir

#endif /* __GO_SNAKE */